---
last_modified_on: "2020-04-06"
delivery_guarantee: "best_effort"
component_title: "Statsd"
description: "The Vector `statsd` sink streams `metric` events to StatsD metrics service."
event_types: ["metric"]
function_category: "transmit"
issues_url: https://github.com/timberio/vector/issues?q=is%3Aopen+is%3Aissue+label%3A%22sink%3A+statsd%22
operating_systems: ["Linux","MacOS","Windows"]
sidebar_label: "statsd|[\"metric\"]"
source_url: https://github.com/timberio/vector/tree/master/src/sinks/statsd.rs
status: "prod-ready"
title: "Statsd Sink"
unsupported_operating_systems: []
---

import Fields from '@site/src/components/Fields';
import Field from '@site/src/components/Field';
import Tabs from '@theme/Tabs';
import TabItem from '@theme/TabItem';

The Vector `statsd` sink
[streams](#streaming) [`metric`][docs.data-model.metric] events to
[StatsD][urls.statsd] metrics service.

<!--
     THIS FILE IS AUTOGENERATED!

     To make changes please edit the template located at:

     website/docs/reference/sinks/statsd.md.erb
-->

## Configuration

<Tabs
  block={true}
  defaultValue="common"
  values={[{"label":"Common","value":"common"},{"label":"Advanced","value":"advanced"}]}>
<TabItem value="common">

```toml title="vector.toml"
[sinks.my_sink_id]
  type = "statsd" # required
  inputs = ["my-source-id"] # required
  address = "127.0.0.1:8125" # optional, default
  healthcheck = true # optional, default
  namespace = "service" # required
```

</TabItem>
<TabItem value="advanced">

```toml title="vector.toml"
[sinks.my_sink_id]
  type = "statsd" # required
  inputs = ["my-source-id"] # required
  address = "127.0.0.1:8125" # optional, default
  healthcheck = true # optional, default
  namespace = "service" # required
```

</TabItem>
</Tabs>

<Fields filters={true}>
<Field
  common={true}
  defaultValue={"127.0.0.1:8125"}
  enumValues={null}
  examples={["127.0.0.1:8125"]}
  groups={[]}
  name={"address"}
  path={null}
  relevantWhen={null}
  required={false}
  templateable={false}
  type={"string"}
  unit={null}
  warnings={[]}
  >

### address

The UDP socket address to send stats to.




</Field>
<Field
  common={true}
  defaultValue={true}
  enumValues={null}
  examples={[true,false]}
  groups={[]}
  name={"healthcheck"}
  path={null}
  relevantWhen={null}
  required={false}
  templateable={false}
  type={"bool"}
  unit={null}
  warnings={[]}
  >

### healthcheck

Enables/disables the sink healthcheck upon start.




</Field>
<Field
  common={true}
  defaultValue={null}
  enumValues={null}
  examples={["service"]}
  groups={[]}
  name={"namespace"}
  path={null}
  relevantWhen={null}
  required={true}
  templateable={false}
  type={"string"}
  unit={null}
  warnings={[]}
  >

### namespace

A prefix that will be added to all metric names.




</Field>
</Fields>


## Examples

```text
gorets:1|c
glork:320|ms
gaugor:333|g
uniques:765|s
```

## How It Works

### Environment Variables

Environment variables are supported through all of Vector's configuration.
Simply add `${MY_ENV_VAR}` in your Vector configuration file and the variable
will be replaced before being evaluated.

You can learn more in the
[Environment Variables][docs.configuration#environment-variables] section.

### Streaming

The `statsd` sink streams data on a real-time
event-by-event basis. It does not batch data.


[docs.configuration#environment-variables]: /docs/setup/configuration/#environment-variables
[docs.data-model.metric]: /docs/about/data-model/metric/
[urls.statsd]: https://github.com/statsd/statsd
