---
last_modified_on: "2020-04-29"
title: "Vector v0.9.0 Release Notes"
codename: "The Homestretch"
date: "2020-04-17"
description: "Vector v0.9.0 - The Homestretch - Release Notes"
version: "0.9.0"
---

import Changelog from '@site/src/components/Changelog';
import HighlightItems from '@theme/HighlightItems';

The [Vector team][pages.community#team] is pleased to release
0.9.0. This is a [initial dev](https://semver.org/#spec-item-4)
release. Checkout the [Highlights](#highlights), [Changelog](#changelog), and
[What's Next](#whats-next) section for more detail.

<!--
     THIS FILE IS AUTOGENERATED!

     To make changes please edit the template located at:

     website/releases/0.9.0.md.erb
-->

## Highlights

<div className="sub-title">Noteworthy changes in this release</div>

<HighlightItems
  author={false}
  colorize={true}
  groupBy={"type"}
  headingDepth={3}
  items={[{"authorGithub":"https://github.com/binarylogic","dateString":"2020-03-23T00:00:00","description":"This brings the sink naming inline with consistent naming pattern","permalink":"/highlights/2020-03-23-rename-gcp_stackdriver_logging-sink-to-gcp_stackdriver_logs/","prNumbers":[2121],"release":"0.9.0","tags":["type: breaking change","domain: sinks","sink: splunk_hec"],"title":"The `gcp_stackdriver_logging` sink has been renamed to `gcp_stackdriver_logs`","type":"breaking change"},{"authorGithub":"https://github.com/binarylogic","dateString":"2020-04-05T00:00:00","description":"Compression is not supported by all Elasticsearch service providers","permalink":"/highlights/2020-04-05-default-compression-to-none/","prNumbers":[2219],"release":"0.9.0","tags":["type: breaking change","domain: sinks","sink: elasticsearch"],"title":"The `elasticsearch` sink `compression` option now defaults to `none`","type":"breaking change"},{"authorGithub":"https://github.com/binarylogic","dateString":"2020-04-09T00:00:00","description":"ACL is not always required when creating objects in GCP Cloud Storage","permalink":"/highlights/2020-04-09-make-acl-optional/","prNumbers":[2283],"release":"0.9.0","tags":["type: breaking change","domain: sinks","sink: gcp_cloud_storage"],"title":"ACL is now optional for the Google Cloud Storage sink","type":"breaking change"},{"authorGithub":"https://github.com/binarylogic","dateString":"2020-03-04T00:00:00","description":"Vector now lets you whitelist, blacklist, and format fields when events are encoded","permalink":"/highlights/2020-03-04-encoding-only-fields-except-fields/","prNumbers":[1915],"release":"0.9.0","tags":["type: enhancement","domain: sinks"],"title":"New Encoding Options","type":"enhancement"},{"authorGithub":"https://github.com/binarylogic","dateString":"2020-04-07T00:00:00","description":"The next iteration of our Lua transform.","permalink":"/highlights/2020-04-07-lua-transform-version-2/","prNumbers":[2126],"release":"0.9.0","tags":["type: enhancement","domain: sources","source: vector"],"title":"Lua Transform v2","type":"enhancement"},{"authorGithub":"https://github.com/binarylogic","dateString":"2020-04-20T00:00:00","description":"A faster and more reliable shutdown process","permalink":"/highlights/2020-04-20-improved-shutdown/","prNumbers":[1994],"release":"0.9.0","tags":["type: enhancement","domain: topology"],"title":"Improved Shutdown","type":"enhancement"},{"authorGithub":"https://github.com/binarylogic","dateString":"2020-02-28T00:00:00","description":"Build Vector with select components","permalink":"/highlights/2020-02-28-custom-vector-builds/","prNumbers":[1924],"release":"0.9.0","tags":["type: new feature","domain: sources","source: vector"],"title":"À La Carte Custom Vector Builds","type":"new feature"},{"authorGithub":"https://github.com/binarylogic","dateString":"2020-03-10T00:00:00","description":"Shed duplicate logs","permalink":"/highlights/2020-03-10-dedupe-transform/","prNumbers":[1848],"release":"0.9.0","tags":["type: new feature","domain: sources","source: vector"],"title":"New Dedupe Transform","type":"new feature"},{"authorGithub":"https://github.com/binarylogic","dateString":"2020-03-11T00:00:00","description":"Protect downstream metrics storages from runaway metrics tags","permalink":"/highlights/2020-03-11-tag-cardinality-limit-transform/","prNumbers":[1959],"release":"0.9.0","tags":["type: new feature","domain: transforms","transform: tag_cardinality_limit"],"title":"New Tag Cardinality Limit Transform","type":"new feature"},{"authorGithub":"https://github.com/binarylogic","dateString":"2020-03-31T00:00:00","description":"Filter and route your logs based on defined conditions","permalink":"/highlights/2020-03-31-filter-transform/","prNumbers":[2088],"release":"0.9.0","tags":["type: new feature","domain: transforms","transform: filter"],"title":"New Filter Transform","type":"new feature"},{"authorGithub":"https://github.com/binarylogic","dateString":"2020-04-17T00:00:00","description":"Papertrail, Honeycomb, Pulsar, and DataDog Logs","permalink":"/highlights/2020-04-17-new-sinks/","prNumbers":[1835,1847,1665,1832],"release":"0.9.0","tags":["type: new feature","domain: sinks"],"title":"4 New Sinks!","type":"new feature"}]}
  size={null}
  tags={false}
  timeline={false} />

## Changelog

<div className="sub-title">A complete list of changes</div>

<Changelog version={"0.9.0"} />

## What's Next

<ul className="connected-list">
<li>

### Kubernetes!

We're doing this integration right. We've been alpha testing with a number of large clusters and we've honed in on a very high-quality approach that reflects the UX Vector is going after. You can learn more in our [Kubernetes Integration RFC][urls.pr_2222]. Feedback is welcome!
</li>
<li>

### WASM Driven Plugin Architecture

This release included an overhaul of our [`lua` transform][docs.transforms.lua], which represents a big step towards making Vector more flexible. Lua is an excellent language when you need some quick scripting capabilities. But what if you need something more powerful? Like writing your own custom source, transform, or sink? Vector plans to solve this with [WASM][urls.wasm] foreign module support, enabling you to extend Vector in the language of your choice with little performance penalty. ❤️ WASM. Check out the [WASM Foreign Module Support RFC][urls.pr_2341] for more info.
</li>
<li>

### Dynamic HTTP Rate-Limiting (AIMD)

Fiddling with rate-limits is a frustratin endaevor. If you set them too high you risk overwhelming the service; too low and you're unecessarily limiting throughput. And what happens if you deploy a few more Vector instances? Vector is planning to solve this by automatically detecting the optimal rate limits, taking inspiration from TCP congestional control algorithms. Check out the [Dynamic HTTP Rate Limiting RFC][urls.pr_2329].
</li>
<li>

### Vector Observability

Did you know this release includes a new hidden `internal` source that emits metrics reflecting Vector's own internal state? 👀 We didn't highlight this source because we have not finished instrumenting Vector and we'll be changing the internal schema used.

Fun fact, we took an event-driven approach to Vector's internal observability, which we strongly beleive in. We want Vector to be a good example of our own advice. Checkout the [Event-Driven Observability RFC][urls.pr_2093].
</li>
</ul>

The [Vector roadmap][urls.vector_roadmap] is publicly available and represents
forward looking progress. Vector is [open-source][urls.vector_repo] and
[community driven][pages.community]. Your feedback is welcome!


[docs.transforms.lua]: /docs/reference/transforms/lua/
[pages.community#team]: /community/#team
[pages.community]: /community/
[urls.pr_2093]: https://github.com/timberio/vector/pull/2093
[urls.pr_2222]: https://github.com/timberio/vector/pull/2222
[urls.pr_2329]: https://github.com/timberio/vector/pull/2329
[urls.pr_2341]: https://github.com/timberio/vector/pull/2341
[urls.vector_repo]: https://github.com/timberio/vector
[urls.vector_roadmap]: https://github.com/timberio/vector/milestones?direction=asc&sort=due_date&state=open
[urls.wasm]: https://webassembly.org/
